function [x]=padding(x,n)

%%% inputs: (1) x = (L,a), where
%%%                 - L is the frequency of the periodic solution
%%%                 - a is the vector of complex Fourier coefficients
%%%         (2) n: the extra 0

L=x(1); %%% The frequency of the periodic orbit
a=x(2:end);

if n>0   
    L = x(1); 
    a = [zeros(n,1);a;zeros(n,1)];
    x=[L;a];
else
    a(1:-n)=[];
    a(end+1+n:end)=[];
    x=[L;a];
end

end