function [sign]=value_of_gamma(I,tx)

% I = [t_min t_max] the interval on which we evaluate gamma

sign=0;

r_gamma=7.595549832526767e-13;

m=length(tx)/2; % m = 16

ta = intval(tx(2:end));

k=intval(-m+1:m-1)';
gamma=sum(ta.*exp(1i*2*intval('pi')*k*I))+infsup(-r_gamma,r_gamma);

if sup(gamma)<0
    sign=-1;
elseif inf(gamma)>0
    sign=1;
end

end

