function [sign]=value_of_gamma_prime(I,tx,nu)

% I = [t_min t_max] the interval on which we evaluate gamma

sign=0;

r_gamma=intval('7.595549832526767e-13');

C1=4*intval('pi')*(2*nu)/((nu-1)^2)*r_gamma;

m=length(tx)/2; % m = 16

ta = intval(tx(2:end));

k=intval(-m+1:m-1)';
gamma=sum(1i*2*intval('pi')*k.*ta.*exp(1i*2*intval('pi')*k*I))+infsup(-inf(C1),sup(C1));

if sup(gamma)<0
    sign=-1;
elseif inf(gamma)>0
    sign=1;
end

end

