function [Jnew,Amnew,B,Ambound]=compute_gradient2_int(alphas,lambda, T,N,Ntilde,a_quad,inu)

iT=intval(T);
ilambda=intval(lambda);
ipi=intval('pi');
i3=intval(3);
i1=intval(1);


J=struct([]);

m=(size(alphas(1).fc,2)+1)/2;


Id=eye(2*m-1);
Zm=zeros(2*m-1);

A2=compute_quad_int([1,1],[0,0],alphas);
C41=intval(120)*Id+i3*tildeMat(A2);
C42=intval(120)*Id;
C43=intval(71)*Id;
for modNa=N:Ntilde
    for al1=modNa:-1:0
        al2=modNa-al1;
        a=[al1,al2];
        J(a(1)+1,a(2)+1).n=a;
    
        mu_a=ipi/(iT)*1i*intval(diag(-m+1:1:m-1))+intval(a)*ilambda.'*Id;
        J(a(1)+1,a(2)+1).jac=[ mu_a,-Id,Zm,Zm;  Zm,mu_a,-Id,Zm;Zm,Zm,mu_a,-Id;C41,C42,C43,mu_a+14*Id];  
    end   
end
a_quad_0_0=a_quad(1,1).fc((size(a_quad(1,1).fc,2)+1)/2);
a_quad_0_4=a_quad(1,1).fc((size(a_quad(1,1).fc,2)+1)/2+4);
a_quad_0_m4=a_quad(1,1).fc((size(a_quad(1,1).fc,2)+1)/2-4);

d0=intval('120')+i3*(a_quad_0_0+midrad(0,a_quad(1,1).eps));
d4=i3*(a_quad_0_4+midrad(0,sup((a_quad(1,1).eps)*inu^(-intval(4)))));
dm4=i3*(a_quad_0_m4+midrad(0,sup((a_quad(1,1).eps)*inu^(-intval(4)))));
f0=intval(154);
g0=intval(71);

[Jnew,Amnew,B,Ambound]=extend_Adaga(J,d0,d4,dm4,f0,g0,m,iT,ilambda,inu,Ntilde);
end

 



function  S=compute_quad_int(J,n,alphas)
            dim_man=length(n); 
            J(J==0)=[];
            vecs= struct('comp', {}) ;
            % all possible combination of length(J) elemnnts that sums up to n(d) 
            for d=1:length(n)
                PRd = perms_rep(n(d)+1,length(J)) ;         %all possible permutation of the numbers 1...NMAX+1 in dm columns
                PRd = PRd-1; 
                PRd(sum(PRd,2)~=n(d),:)=[];
                vecs(d).comp=PRd;
            end
           
             for l=1:length(n)
                 dimcomp(l)=size(vecs(l).comp,1);
             end
             if length(n)==1
                  ALP(:,1)=[1:dimcomp(1)].';
             else
            ALP(:,1)=repmat([1:dimcomp(1)].',dimcomp(2),1);
            ALP(:,2)=kron([1:dimcomp(2)].',ones(dimcomp(1),1));
            for l=3:length(n)
                ALP=repmat(ALP,dimcomp(l),1);
                ALP=[ALP,kron([1:dimcomp(l)].',ones(ALP,1))];
             
            end
             end
            M_comp=prod(dimcomp);
           Alphasj=zeros(length(J),length(n),M_comp);
           for ii=1:M_comp
               for jj=1:length(n)
               Alphasj(:,jj,ii)=(vecs(jj).comp(ALP(ii,jj),:)).';
               end
           end

           
            S=intval(0);
            for ii=1:size(Alphasj,3)
                v1=Alphasj(1,:,ii);
                position1=num2cell(v1+ones(1,dim_man));
                al1=getfield(alphas,position1,'fc');
                al1=intval(al1(J(1),:));
                Conv=al1;
                for jj=2:size(Alphasj,1)
                    vj=Alphasj(jj,:,ii);
                    positionj=num2cell(vj+ones(1,dim_man));
                    alj=getfield(alphas,positionj,'fc');
                    alj=intval(alj(J(jj),:));
                    Conv=quadratic_sumFFT_complex_int(Conv.',alj.').';
                end
                S=S+Conv;
            end
        end
              
function [s]=quadratic_sumFFT_complex_int(a1,a2)


i2=intval('2');
i4=intval('4');

if size(a1,2)>1
    a1=a1.';
end
if size(a2,2)>1
    a2=a2.';
end
M=(length(a1)+1)/2;



% We make sure that the inputs are powers of 2 %
M1=(2^ceil(log(4*M-1)/log(2))-4*M)/2;   % Hence 4*M+2*M1 is a power of 2 %
ta1=[intval(zeros(M+M1+1,1));a1;intval(zeros(M+M1,1))];
ta2=[intval(zeros(M+M1+1,1));a2;intval(zeros(M+M1,1))];
tu1=verifyfft(ifftshift(ta1),-1);
tu2=verifyfft(ifftshift(ta2),-1);
F=fftshift(verifyfft(tu1.*tu2,1));
s=(i4*intval(M)+i2*intval(M1))*F(M1+M+2:M1+3*M,1);
end


function tildeA=tildeMat(a)
m=(length(a)+1)/2;
if  isa(a,'intval')
a=[intval(zeros(1,m-1)),a,intval(zeros(1,m-1))];
else
    a=[zeros(1,m-1),a,zeros(1,m-1)];
end
center=2*m-1;

if  isa(a,'intval')
tildeA=intval(zeros(2*m-1));    
else
tildeA=zeros(2*m-1);
end

for N=-m+1:m-1
   tildeA(m+N,:)=a(center+N-[-m+1:1:m-1]); 
end

end


function [Jnew,Amnew,B,Ambound]=extend_Adaga(Jac,d0,d4,dm4,f0,g0,m,T,lambda,nu,Ntilde)
ipi=intval('pi');
i0=intval(0);
i1=intval(1);
s=size(Jac);
n=numel(Jac);

M=16;
%Jnew_tot=intval(zeros(s*(2*m+M-1)));%cell(s);
Jnew=struct([]);
Amnew=struct([]);
B=struct([]);
Zm4=zeros(2*(m+4)-1);
Im4=diag([zeros(1,4),ones(1,2*m-1),zeros(1,4)]);
P=[Zm4,-Im4,Zm4,Zm4;Zm4,Zm4,-Im4,Zm4;Zm4,Zm4,Zm4,-Im4;Zm4,Zm4,Zm4,14*Im4];

for l=1:n
    if isempty(Jac(l).n)==0 
        al=intval(Jac(l).n);
        J_cell=mat2cell(Jac(l).jac, ones(1,4)*(2*m-1),ones(1,4)*(2*m-1));
        Jnew_tot=intval(zeros(4*(2*m+M-1)));
        Jnew_al=intval(zeros(2*(m+M/4)-1));%cell(4);
%    al=intval(vec_al(fix(i/4-1/8)+1,:));
    for i=1:4
    for j=1:4
        W=intval(zeros(2*m-1+M));       
        if i==j
            W=diag(muk(-m-M/2+1:m+M/2-1,al,lambda,T));
        end
        if i==4 && j==1
            W=diag(d0*ones(1,2*m+M-1));
           K=-m-M/2+1:m+M/2-4-1;
           W=W+diag(dm4*ones(size(K)),4);
           K=-m-M/2+4+1:m+M/2-1;
           W=W+diag(d4*ones(size(K)),-4);
           
           
        end
         if i==4 && j==2
             W=diag(f0*ones(1,2*m+M-1));
       
         end
          if i==4 && j==3
             W=diag(g0*ones(1,2*m+M-1));
              
         end
  
        W(m+M/2+[-m+1:m-1],m+M/2+[-m+1:m-1])=J_cell{i,j}; 
        Jnew_tot((i-1)*(2*m+M-1)+[1:2*m+M-1],(j-1)*(2*m+M-1)+[1:2*m+M-1])=W;
        Jnew_al((i-1)*(2*m+M/2-1)+[1:2*m+M/2-1],(j-1)*(2*m+M/2-1)+[1:2*m+M/2-1])=W(m+M/2+[-m-M/4+1:m+M/4-1],m+M/2+[-m-M/4+1:m+M/4-1]);        
    end
    end
    midal=al.mid;
    Jnew(midal(1)+1,midal(2)+1).n=midal;
    Jnew(midal(1)+1,midal(2)+1).jac=Jnew_al;
    Jnew_al_cell=mat2cell(Jnew_al,ones(1,4)*(2*m+M/2-1),ones(1,4)*(2*m+M/2-1));
    Amnew(midal(1)+1,midal(2)+1).n=midal;
    B(midal(1)+1,midal(2)+1).n=midal;
    if sum(al.mid)<Ntilde
       Am_al= inv(Jnew_al.mid);
   

    else    
  
    mu_ainv=diag((ipi/(T)*1i*intval(-m-4+1:1:m+4-1)+al*lambda.').^(-i1));
    C41=Jnew_al_cell{4,1};
    C42=Jnew_al_cell{4,2};
    C43=Jnew_al_cell{4,3};
    
    B_tilde_al=[mu_ainv,Zm4,Zm4,Zm4;Zm4,mu_ainv,Zm4,Zm4;Zm4,Zm4,mu_ainv,Zm4;...
               -mu_ainv*C41*mu_ainv, -mu_ainv*C42*mu_ainv, -mu_ainv*C43*mu_ainv,mu_ainv];
    Am_al=B_tilde_al-B_tilde_al*P*B_tilde_al;
    
 %   residual2=B_tilde_al*P*B_tilde_al*P; 
    Ambound(midal(1)+1,midal(2)+1).n=midal;
    Ambound(midal(1)+1,midal(2)+1).norm(1,1)=sup(abs(al*lambda.').^(-i1));
    Ambound(midal(1)+1,midal(2)+1).norm(1,2)= sup(norm_dual(mu_ainv*Im4*mu_ainv,nu));
    Ambound(midal(1)+1,midal(2)+1).norm(1,3)=0;
    Ambound(midal(1)+1,midal(2)+1).norm(1,4)=0;
    Ambound(midal(1)+1,midal(2)+1).norm(2,1)=0;
    Ambound(midal(1)+1,midal(2)+1).norm(2,2)=sup(abs(al*lambda.').^(-i1));
    Ambound(midal(1)+1,midal(2)+1).norm(2,3)= sup(norm_dual(mu_ainv*Im4*mu_ainv,nu));
    Ambound(midal(1)+1,midal(2)+1).norm(2,4)=0;
    Ambound(midal(1)+1,midal(2)+1).norm(3,1)=sup(norm_dual(mu_ainv*Im4*mu_ainv*abs(C41)*mu_ainv,nu));
    Ambound(midal(1)+1,midal(2)+1).norm(3,2)=sup(norm_dual(mu_ainv*Im4*mu_ainv*abs(C42)*mu_ainv,nu));
    Ambound(midal(1)+1,midal(2)+1).norm(3,3)=sup(norm_dual(mu_ainv+mu_ainv*Im4*mu_ainv*abs(C43)*mu_ainv,nu));
    Ambound(midal(1)+1,midal(2)+1).norm(3,4)= sup(norm_dual(mu_ainv*Im4*mu_ainv,nu));
    Ambound(midal(1)+1,midal(2)+1).norm(4,1)= (1+sup(norm_dual(mu_ainv* abs(C43)*mu_ainv*Im4+14*mu_ainv*Im4,nu)))*sup(norm_dual(mu_ainv*abs(C41)*mu_ainv,nu));
    Ambound(midal(1)+1,midal(2)+1).norm(4,2)= sup(norm_dual(mu_ainv*abs(C41)*mu_ainv*Im4*mu_ainv,nu))+(1+sup(norm_dual(mu_ainv*abs(C43)*mu_ainv*Im4+14*mu_ainv*Im4,nu)))*sup(norm_dual(mu_ainv*abs(C42)*mu_ainv,nu));
    Ambound(midal(1)+1,midal(2)+1).norm(4,3)= sup(norm_dual(mu_ainv*abs(C42)*mu_ainv*Im4*mu_ainv,nu))+(1+sup(norm_dual(mu_ainv*abs(C43)*mu_ainv*Im4+14*mu_ainv*Im4,nu)))*sup(norm_dual(mu_ainv*abs(C43)*mu_ainv,nu));
    Ambound(midal(1)+1,midal(2)+1).norm(4,4)= sup(norm_dual(mu_ainv*abs(C43)*mu_ainv*Im4*mu_ainv,nu))+sup(abs(al*lambda.').^(-i1))+14*sup(norm_dual(mu_ainv*Im4*mu_ainv,nu));
    end
  
    Amnew_al_cell=mat2cell(Am_al,ones(1,4)*(2*m+M/2-1),ones(1,4)*(2*m+M/2-1));

    Amnew(midal(1)+1,midal(2)+1).Am=Amnew_al_cell;
        
  
    
    Anew_tot=cell(4,4);
    Atot=intval(zeros(4*(2*m+M-1)));
    for i=1:4
        for j=1:4
        W=intval(zeros(2*m-1+M));
         if i==j
            W=diag((muk(-m-M/2+1:m+M/2-1,al,lambda,T)).^(-1));
         end
         if i==4 && j==1
           W=diag(-d0*(muk(-m-M/2+1:m+M/2-1,al,lambda,T)).^(-2));
           K=-m-M/2+1:m+M/2-4-1;
           W=W+diag(-dm4*(muk(K+4,al,lambda,T).*(muk(K,al,lambda,T))).^(-1),4);
           K=-m-M/2+4+1:m+M/2-1;
           W=W+diag(-d4.mid*(mid(muk(K-4,al,lambda,T)).*mid(muk(K,al,lambda,T))).^(-1),-4);
         end
         if i==4 && j==2
           W=diag(-f0*((muk(-m-M/2+1:m+M/2-1,al,lambda,T))).^(-2));
         end
         if i==4 && j==3
           W=diag(-g0*((muk(-m-M/2+1:m+M/2-1,al,lambda,T))).^(-2));
         end
           MatA=Amnew_al_cell{i,j};
        S=(size(MatA)+1)/2;
         n1=S(1); n2=S(2);
         MatA(n1,n2)=real(MatA(n1,n2));
         MatA(n1,1:n2-1)=flip(conj(MatA(n1,n2+1:end)),2);
         MatA(n1+1:end,:)=flip(flip(conj(MatA(1:n1-1,:)),2),1);
         Amnew_al_cell{i,j}=MatA;
%          
         
          W(m+M/2+[-m-M/4+1:m+M/4-1],m+M/2+[-m-M/4+1:m+M/4-1])=MatA;
          Anew_tot{i,j}=W;
          Atot((i-1)*(2*m+M-1)+[1:2*m+M-1],(j-1)*(2*m+M-1)+[1:2*m+M-1])=W;
         Amnew(l).norm(i,j)=norm_dual(W,nu);
   
       end
       
    end


  residual=intval(eye(size(Atot)))-intval(Atot)*Jnew_tot;
  residual_cell=mat2cell(residual,ones(1,4)*(2*m+M-1),ones(1,4)*(2*m+M-1));
    for i=1:4
        for j=1:4
             B(l).norm(i,j)=norm_dual(residual_cell{i,j},nu);
        end
    end
            
   
    end
end

    
  
end
function q=muk(k,al,lambda,T)
    ipi=intval('pi');
q=ipi*1i/(T)*intval(k)+intval(al)*lambda.';

end
function Nor=norm_dual(A,nu)
%Assume A maps bi-sequences in bi-sequences
m1=(size(A,1)+1)/2;
m2=(size(A,2)+1)/2;
inu=intval(nu);
K=inu.^intval(abs(-m1+1:1:m1-1))*abs(A);

Nor=max(sup([K./(inu.^intval(abs(-m2+1:1:m2-1)))]));



end





