function [r,aquad,a_quad_0_star,alphas]=proof_high_order_terms_bridgeNM(f_int, Jac_int,lambda,T,par2,nu, alphas, Epsilon,m)

i0=intval(0);
i1=intval(1);
i2=intval(2);
i3=intval(3);
ipi=intval('pi');
inu=intval(nu);


space_dim=par2(1);
N_man=par2(3);

ilambda=lambda;
iT=intval(T);

vec_al=[];
for modN=2:N_man
    for al1=modN:-1:0
        al2=modN-al1;
        vec_al=[vec_al;[al1,al2]];
    end
end
number_al=size(vec_al,1);
q=1;
for i=1:size(vec_al,1)
    for d=1:space_dim
        indeces(q).al=vec_al(i,:);
        indeces(q).j=d;
        q=q+1;
    end
end
N_ind=length(indeces);

%%% augment the finite dimensional projection for the out of diagonal
%%% elemnets
m=m+4;

for i=1:numel(alphas)
    if isempty(alphas(i).n)==0
        alphas(i).norm=norm_nu(alphas(i).fc(1,:),inu);
    end
end


%%  rearrange the elemnts of f(\bar x)
f_al=reshape(f_int,[],number_al);             % split into different alphas
f_int_m=[];
F=struct([]);
for al=1:number_al
    fal=reshape(f_al(:,al),[],4);             % split into different j
    S=(size(fal,1)+1)/2;
    for i=1:4
        f_al_i=fal(:,i);
        F(al,i).m=f_al_i(S+[-m+1:m-1]);       %separates the central part of f(x) from the tail parts
        F(al,i).neg=f_al_i(1:S-m);
       % F(al,i).m=f_al_i(N(i):3*N(i)-2);
        F(al,i).pos=f_al_i(S+m:end);
      %  fal(1:4*N(i)-3)=[];
        f_int_m=[f_int_m;F(al,i).m];       
    end
end
%%%%  a^2 % computes the convolution a^2_\alphas and the epsilon_norm
a_quad=compute_a_quad(alphas,N_man,inu,Epsilon);
a_quad_0_0=a_quad(1,1).fc((size(a_quad(1,1).fc,2)+1)/2);
a_quad_0_4=a_quad(1,1).fc((size(a_quad(1,1).fc,2)+1)/2+4);
a_quad_0_m4=a_quad(1,1).fc((size(a_quad(1,1).fc,2)+1)/2-4);

d0=intval('120')+i3*(a_quad_0_0+midrad(0,a_quad(1,1).eps));
d4=i3*(a_quad_0_4+midrad(0,sup((a_quad(1,1).eps)*inu^(intval(4)))));
dm4=i3*(a_quad_0_m4+midrad(0,sup((a_quad(1,1).eps)*inu^(intval(4)))));
f0=intval(154);
g0=intval(71);
  %%%%%%%%%
[Amcell,A_oper_norm,B]=extend_Adaga(Jac_int,d0,d4,dm4,f0,g0,m-4,iT,vec_al,ilambda,inu);

Am=cell2mat(Amcell);
% bound Y=A*f(x)

Y_m=intval(Am)*f_int_m;
Y_al=reshape(Y_m,[],size(vec_al,1));
for al=1:size(vec_al,1)
    Yal=reshape(Y_al(:,al),[],4);
    for i=1:4      
        Yk(al,i).mid=Yal(:,i);        
    end
end



seq=1;  % move along the main diagonal of A
for al=1:size(vec_al,1)
    ial=intval(vec_al(al,:));
    sm=(size(F(al,1).m,1)+1)/2;  %=m
    for i=1:4
        fneg=F(al,i).neg;
        fmid=F(al,i).m;
        fpos=F(al,i).pos;
        
        f_tot=[fneg;zeros(size(fmid));fpos];
        S=(size(f_tot,1)+1)/2;
        Y_tot=(muk(-S+1:S-1,ial,ilambda,iT).^(-i1)).'.*f_tot;
        Y_tot(S+[-sm+1:sm-1])=Yk(al,i).mid;
        Yk(al,i).tot=Y_tot;
        if i==4
           A1=diag(-d0*(muk(-S+1:S-1,ial,ilambda,iT)).^(-i2));
           K=-S+1:S-4-1;
           A1=A1+diag(-dm4*(muk(K+4,ial,ilambda,iT).*muk(K,ial,ilambda,iT)).^(-i1),4);
           K=-S+4+1:S-1;
           A1=A1+diag(-d4*(muk(K-4,ial,ilambda,iT).*muk(K,ial,ilambda,iT)).^(-i1),-4);
           A1(S+[-m+1:m-1],S+[-m+1:m-1])=zeros(2*m-1); 
           A2=-f0*(muk(-S+1:S-1,ial,ilambda,iT)).^(-i2);
           A2(S+[-m+1:m-1])=zeros(1,2*m-1);
          
           A3=-g0*(muk(-S+1:S-1,ial,ilambda,iT)).^(-i2);
           A3(S+[-m+1:m-1])=zeros(1,2*m-1);
           
           f_tot1=[F(al,1).neg;F(al,1).m;F(al,1).pos];
           f_tot2=[F(al,2).neg;F(al,2).m;F(al,2).pos];
           f_tot3=[F(al,3).neg;F(al,3).m;F(al,3).pos];
           
           Y_2=A1*f_tot1+A2.'.*f_tot2+A3.'.*f_tot3;
           Yk(al,i).tot=Yk(al,i).tot+Y_2;
            
        end
        
                   
    end
end


         
    
   

for al=1:size(vec_al,1)
    for i=1:4
        Y(seq)=norm_nu(Yk(al,i).tot,inu);
        seq=seq+1;
    end
end
epsilon_F=intval(zeros(N_ind,1));

for q=1:size(vec_al,1)
    al=vec_al(q,:);
    Alj=choose_alphas(al,3);
    eF_al=0;
        for i=1:size(Alj,3)           
            if sum(sum(Alj(:,:,i),2)<2)>0
                Al=Alj(:,:,i);
                for k=1:3                            
                    normnu(k)=alphas(Al(k,1)+1,Al(k,2)+1).norm;
                    if sum(Al(k,:))<2
                       eps=getfield(Epsilon,num2cell(Al(k,:)+1),'r');
                       factor(k)=normnu(k)+eps(1);
                    else
                        factor(k)=normnu(k);
                    end                       
                end
                eF_al=eF_al+(prod(factor)-prod(normnu));
            end
        
            
            
        end
    epsilon_F((q-1)*4+1:4*q)=[i0;i0;i0;eF_al];
    
end
clear normnu factor
Y=Y+(intval(A_oper_norm)*epsilon_F).';

display(['max of Y = ',num2str( norm(Y.sup,inf))])
% bound Z(r)

%Z0=|(I-A^mA)c|


Bcell=mat2cell(B,(2*(m+4)-1)*ones(1,N_ind),(2*(m+4)-1)*ones(1,N_ind));

normB=cellfun(@(x) norm_dual(x,inu),Bcell);
Z0=sum(normB,2);
clear Jac_int Am f_int B Bcell

epsilon_Adag=intval(zeros(N_ind,1));

for q=1:size(vec_al,1)
    al=vec_al(q,:);
    Alj=choose_alphas(al,3);
    eAdag_al=0;
        for i=1:size(Alj,3)  
            if sum(Alj(end,:,i),2)>=2
              if sum(sum(Alj(1:end-1,:,i),2)<2)>0
                Al=Alj(:,:,i);
                for k=1:2
                    normnu(k)=alphas(Al(k,1)+1,Al(k,2)+1).norm;
                    if sum(Al(k,:))<2
                       eps=getfield(Epsilon,num2cell(Al(k,:)+1),'r');
                       factor(k)=normnu(k)+eps(1);
                    else
                        factor(k)=normnu(k);
                    end                       
                end
                eAdag_al=eAdag_al+(prod(factor)-prod(normnu));
              end
            end
            
            
        end
    epsilon_Adag((q-1)*4+1:4*q)=[i0;i0;i0;i3*eAdag_al];
    
end
Z0=Z0+(intval(A_oper_norm)*epsilon_Adag);

display(['max of Z0 = ',num2str( norm(Z0.sup,inf))])

%%%% bound Z1

aquad=a_quad;
a_quad(1,1).fc((size(a_quad(1,1).fc,2)+1)/2)=0;
a_quad(1,1).fc((size(a_quad(1,1).fc,2)+1)/2+4)=0;
a_quad(1,1).fc((size(a_quad(1,1).fc,2)+1)/2-4)=0;
norm_aquad_0_star=norm_nu(a_quad(1,1).fc,inu);
a_quad_0_star.fc=a_quad(1,1).fc;
a_quad_0_star.norm=norm_aquad_0_star;
a_quad_0_star.eps=a_quad(1,1).eps;

m0=(size(a_quad_0_star.fc,2)+1)/2;
tilde0starBig=toeplitz([a_quad_0_star.fc(m0:end),zeros(1,2*m0)],[a_quad_0_star.fc(m0:-1:1),zeros(1,2*m0)]);
m0star=(size(tilde0starBig,1)+1)/2;
tilde0starBig(m0star+[-(m-4)+1:(m-4)-1],m0star+[-(m-4)+1:(m-4)-1])=zeros(2*(m-4)-1);
tilde0star=tilde0starBig(m0star+[-m+1:m-1],m0star+[-m+1:m-1]);




Z1=intval(zeros(1,N_ind));
epsGamma=intval(zeros(N_ind));

for qal=1:size(vec_al,1)
    al=vec_al(qal,:);
    ial=intval(al);
   
    for sal=1:size(vec_al,1)
     Z_al(1)=0;
     Z_al(2)=0;
     Z_al(3)=0;
     Z_al(4)=0;
       if norm(A_oper_norm(4*(qal-1)+[1:4],4*(sal-1)+[1:4]),inf)>0
             al_s=vec_al(sal,:);
             
             if sal==qal
                Z_al(1)=Z_al(1)+max([sup(abs(muk(m+4,ial,ilambda,iT)^(-i1))) ,normAItilde(Amcell{4*(qal-1)+1,4*(sal-1)+1},inu)]);
                Z_al(2)=Z_al(2)+max([sup(abs(muk(m+4,ial,ilambda,iT)^(-i1))) ,normAItilde(Amcell{4*(qal-1)+2,4*(sal-1)+2},inu)]);
                Z_al(3)=Z_al(3)+max([sup(abs(muk(m+4,ial,ilambda,iT)^(-i1))) ,normAItilde(Amcell{4*(qal-1)+3,4*(sal-1)+3},inu)]);
                Z_al(4)=Z_al(4)+sup(intval(14)*max([sup(abs(muk(m+4,ial,ilambda,iT)^(-i1))) ,normAItilde(Amcell{4*(qal-1)+4,4*(sal-1)+4},inu)]))+...
                    norm3diagtilde(Amcell{4*(qal-1)+4,4*(sal-1)+1},d0,d4,dm4,inu,ial,ilambda,iT)+...
                    max([sup(abs(f0)*muk(m+4,ial,ilambda,iT)^(-i2)) ,normAItilde(Amcell{4*(qal-1)+4,4*(sal-1)+2},inu)])+...
                    max([sup(abs(g0)*muk(m+4,ial,ilambda,iT)^(-i2)) ,normAItilde(Amcell{4*(qal-1)+4,4*(sal-1)+3},inu)])+...
                    sup(i3*norm44star(Amcell{4*(qal-1)+4,4*(sal-1)+4},tilde0starBig,ial,ilambda,iT,inu));
                    
                    
                
             else
                Z_al(1)=Z_al(1)+normAItilde(Amcell{4*(qal-1)+1,4*(sal-1)+1},inu);
                Z_al(2)=Z_al(2)+normAItilde(Amcell{4*(qal-1)+2,4*(sal-1)+2},inu);
                Z_al(3)=Z_al(3)+normAItilde(Amcell{4*(qal-1)+3,4*(sal-1)+3},inu);
                Z_al(4)=Z_al(4)+sup(intval(14)*normAItilde(Amcell{4*(qal-1)+4,4*(sal-1)+4},inu))...
                    +normAItilde(Amcell{4*(qal-1)+4,4*(sal-1)+1},nu)+normAItilde(Amcell{4*(qal-1)+4,4*(sal-1)+2},nu)+...
                    normAItilde(Amcell{4*(qal-1)+4,4*(sal-1)+3},nu)+...
                    sup(i3*norm_dual(intval(Amcell{4*(qal-1)+4,4*(sal-1)+4})*tilde0star,nu));
             end
            Z_al(1)=Z_al(1)+normAItilde(Amcell{4*(qal-1)+1,4*(sal-1)+2},nu)+normAItilde(Amcell{4*(qal-1)+1,4*(sal-1)+3},nu)+...
                    sup(intval(14)*normAItilde(Amcell{4*(qal-1)+1,4*(sal-1)+4},nu)+i3*norm_dual(intval(Amcell{4*(qal-1)+1,4*(sal-1)+4})*tilde0star,nu));
            Z_al(2)=Z_al(2)+normAItilde(Amcell{4*(qal-1)+2,4*(sal-1)+1},nu)+normAItilde(Amcell{4*(qal-1)+2,4*(sal-1)+3},nu)+...
                    sup(intval(14)*normAItilde(Amcell{4*(qal-1)+2,4*(sal-1)+4},nu)+i3*norm_dual(intval(Amcell{4*(qal-1)+2,4*(sal-1)+4})*tilde0star,nu));
            Z_al(3)=Z_al(3)+normAItilde(Amcell{4*(qal-1)+3,4*(sal-1)+1},nu)+normAItilde(Amcell{4*(qal-1)+3,4*(sal-1)+2},nu)+...
                    sup(intval(14)*normAItilde(Amcell{4*(qal-1)+3,4*(sal-1)+4},nu)+i3*norm_dual(intval(Amcell{4*(qal-1)+3,4*(sal-1)+4})*tilde0star,nu));
            
                
                beta=find(sum((repmat(al_s,size(vec_al,1),1)-vec_al)>=0,2)==2);
                in_beta=find(sum(repmat(al,size(beta,1),1)-vec_al(beta,:),2)>0);
                delta=repmat(al,size(in_beta,1),1)-vec_al(beta(in_beta),:);
                for l=1:size(delta,1)
                    a_quad_delta=a_quad(delta(1)+1,delta(2)+1).fc;
                    m0=(size(a_quad_delta,2)+1)/2;
                    tildedeltaBig=toeplitz([a_quad_delta(m0:end),zeros(1,2*m0)],[a_quad_delta(m0:-1:1),zeros(1,2*m0)]);
                    m0star=(size(tildedeltaBig,1)+1)/2;
                    tildedeltaBig(m0star+[-(m-4)+1:(m-4)-1],m0star+[-(m-4)+1:(m-4)-1])=zeros(2*(m-4)-1);
                    tildedelta=tildedeltaBig(m0star+[-m+1:m-1],m0star+[-m+1:m-1]);

                    Z_al(1)=Z_al(1)+sup(i3*norm_dual(intval(Amcell{4*(qal-1)+1,4*(sal-1)+4})*tildedelta,inu));
                    Z_al(2)=Z_al(2)+sup(i3*norm_dual(intval(Amcell{4*(qal-1)+2,4*(sal-1)+4})*tildedelta,inu));
                    Z_al(3)=Z_al(3)+sup(i3*norm_dual(intval(Amcell{4*(qal-1)+3,4*(sal-1)+4})*tildedelta,inu));
                    if sal==qal
                        Z_al(4)=Z_al(4)+sup(i3*norm44star(Amcell{4*(qal-1)+4,4*(sal-1)+4},tildedeltaBig,ial,ilambda,iT,inu));
                    else
                        Z_al(4)=Z_al(4)+sup(i3*norm_dual(intval(Amcell{4*(qal-1)+4,4*(sal-1)+4})*tildedelta,inu));
                    end
                end
          Z1(4*(qal-1)+1)=Z1(4*(qal-1)+1)+Z_al(1);   
          Z1(4*(qal-1)+2)=Z1(4*(qal-1)+2)+Z_al(2);
          Z1(4*(qal-1)+3)=Z1(4*(qal-1)+3)+Z_al(3);   
          Z1(4*(qal-1)+4)=Z1(4*(qal-1)+4)+Z_al(4);        
       end
   
    end
    
end
for s=1:N_ind
    for t=1:N_ind
        
        s_j=indeces(s).j;
        t_j=indeces(t).j;
        if s_j==4 && t_j==1
            s_al=indeces(s).al;
            t_al=indeces(t).al;
             if sum((s_al-t_al)<0)==0
               Al=s_al-t_al+1;
               epsGamma(s,t)=i3*a_quad(Al(1),Al(2)).eps;
             end
        end
    end
end
Z1=Z1.'+sup(sum(intval(A_oper_norm)*intval(epsGamma),2));
display(['max of Z1 = ',num2str( norm(Z1.sup,inf))])

%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%  Z2 bound %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
V2=[];
V3=[];
for q=1:size(vec_al,1)
    al=vec_al(q,:);
    Alj=choose_alphas(al,3);
    remove=[];
    for i=1:size(Alj,3)
        if sum(Alj(2,:,i))<2 || sum(Alj(3,:,i))<2
            remove=[remove,i];
        end
    end
    
    Alj(:,:,remove)=[];
    sumup2=0;
    sumup3=0;
    for i=1:size(Alj,3)
        al=Alj(1,:,i);
        position=num2cell(al+1);
        a_al=getfield(alphas,position,'fc');
        sumup2=sumup2+norm_nu(a_al(1,:),inu);
        if sum(al)<2
            eps=getfield(Epsilon,position,'r');
            sumup2=sumup2+eps(1);
        end
        if sum(al)>=2
            sumup3=sumup3+1;
        end
        
    end
    V2=[V2;[0;0;0;6*sumup2]];
    V3=[V3;[0;0;0;3*sumup3]];
    
end


normA=A_oper_norm;

Z2=intval(normA)*V2;
Z2=Z2+10^-15;   % to avoid Z2=0
display(['max of Z2 = ',num2str( norm(Z2.sup,inf))])

Z3=intval(normA)*V3;
Z3=Z3+10^-15;   % to avoid Z2=0
display(['max of Z3 = ',num2str( norm(Z3.sup,inf))])

ip=[Z3.sup Z2.sup sup(Z0)+sup(Z1.sup)-1 sup(Y.sup).'];
p=mid(ip);

%save poly p ip Y Z0 Z1 Z2

I=zeros(size(p,1),3);
for k=1:size(p,1)
    R=roots(p(k,:));
    R=sort(R);
    Int=R';
    I(k,:)=Int;
end

I=[max(I(:,end-1)) min(I(:,end))];

if norm(imag(I))>0
    display('FAILURE !')
    I=[-1 1];
    success=0;
elseif I(1)<0
    display('FAILURE !')
    I=[-1 1];
    success=0;
else
    %r=(I(1)+I(2))/2;
    r=I(1)*1.1;
    ir=intval(r);
    pr=p(:,1)*ir^2+p(:,2)*ir+p(:,3);
    if max(sup(pr))<0
        display('SUCCESS !')
        %display(['r = ',num2str(r)])
    else
        display('FAILURE ! max(sup(pr))>=0')
    end
    success=1;
end


end
%%%%%%%%%%%%%%%%%%%


    





%%%%%%%%%%%%%
   
%%%%%%%%%%%%%%%%%%
   



function Nor=norm_nu(a,nu)
if size(a,1)==1
    a=a.';
end
inu=intval(nu);
m=(length(a)+1)/2;
Nor=(inu.^intval(abs(-m+1:1:m-1)))*abs(intval(a));

end

function Nor=norm_dual(A,nu)
%Assume A maps bi-sequences in bi-sequences
m1=(size(A,1)+1)/2;
m2=(size(A,2)+1)/2;
inu=intval(nu);
K=inu.^intval(abs(-m1+1:1:m1-1))*abs(intval(A));

Nor=max(sup([K./(inu.^intval(abs(-m2+1:1:m2-1)))]));



end
%%%%%%%%%








function a_quad=compute_a_quad(alphas,N_man,inu,Epsilon)
a_quad= struct('n', {}, 'fc', {},'eps',{}) ;
vec_al=[];
for modN=0:2*N_man
    for al1=modN:-1:0
        al2=modN-al1;
      
        vec_al=[vec_al;[al1,al2]];
    end
end
for i=1:size(vec_al,1)
    al=vec_al(i,:);
    position=num2cell(al+1);
    a_quad=setfield(a_quad,position,'n',al);
    [S,err]=compute_quad_int([1,1],al,alphas,inu,Epsilon,N_man);
    a_quad=setfield(a_quad,position,'fc',S);
    a_quad=setfield(a_quad,position,'eps',err.sup);
    a_quad=setfield(a_quad,position,'norm', sup(norm_nu(S,inu))+err.sup);
end
end
function  [S,error]=compute_quad_int(J,n,alphas,inu,Epsilon,N)
dim_man=length(n);
J(J==0)=[];
Alphasj=choose_alphas(n,2);
if sum(n)>N
   remove=find(sum((sum(Alphasj,2)-N)>0,1));
   Alphasj(:,:,remove)=[];
end

S=intval(0);
error=intval(0);
for ii=1:size(Alphasj,3)
    v1=Alphasj(1,:,ii);
    v2=Alphasj(2,:,ii);
    position1=num2cell(v1+ones(1,dim_man));
    position2=num2cell(v2+ones(1,dim_man));
    al1=getfield(alphas,position1,'fc');
    al1=intval(al1(J(1),:));
    al2=getfield(alphas,position2,'fc');
    al2=intval(al2(J(2),:));
    Conv=quadratic_sumFFT_complex_int(al1.',al2.').';

    S=S+Conv;
    
    
     if sum(sum(Alphasj(:,:,ii),2)<2)>0
                Al=Alphasj(:,:,ii);
     
              error=error+alphas(Al(1,1)+1,Al(1,2)+1).norm*alphas(Al(2,1)+1,Al(2,2)+1).eps(1)+...
                          alphas(Al(2,1)+1,Al(2,2)+1).norm*alphas(Al(1,1)+1,Al(1,2)+1).eps(1)+...
                          alphas(Al(1,1)+1,Al(1,2)+1).eps(1)*alphas(Al(2,1)+1,Al(2,2)+1).eps(1);
                      

     end   
end
end


function [s]=quadratic_sumFFT_complex_int(a1,a2)
i2=intval('2');
i4=intval('4');

if size(a1,2)>1
    a1=a1.';
end
if size(a2,2)>1
    a2=a2.';
end
M=(length(a1)+1)/2;



% We make sure that the inputs are powers of 2 %
M1=(2^ceil(log(4*M-1)/log(2))-4*M)/2;   % Hence 4*M+2*M1 is a power of 2 %
ta1=[intval(zeros(M+M1+1,1));a1;intval(zeros(M+M1,1))];
ta2=[intval(zeros(M+M1+1,1));a2;intval(zeros(M+M1,1))];
tu1=verifyfft(ifftshift(ta1),-1);
tu2=verifyfft(ifftshift(ta2),-1);
F=fftshift(verifyfft(tu1.*tu2,1));

s=(i4*intval(M)+i2*intval(M1))*F(M1+3:M1+4*M-1,1);
end



function [Anew_cell,norm_A,B]=extend_Adaga(Jac,d0,d4,dm4,f0,g0,m,T,vec_al,lambda,nu)
s=size(Jac,1)/(2*m-1);
J_cell=mat2cell(Jac, ones(1,s)*(2*m-1),ones(1,s)*(2*m-1));
M=16;
Jnew_tot=intval(zeros(s*(2*m+M-1)));%cell(s);
Jnew=cell(s);

for i=1:s
    al=intval(vec_al(fix(i/4-1/8)+1,:));
    for j=1:s
        W=intval(zeros(2*m-1+M));       
        if i==j
            W=diag(muk(-m-M/2+1:m+M/2-1,al,lambda,T));
        end
        if mod(i,4)==0 && j==i-3
            W=diag(d0*ones(1,2*m+M-1));
           K=-m-M/2+1:m+M/2-4-1;
           W=W+diag(dm4*ones(size(K)),4);
           K=-m-M/2+4+1:m+M/2-1;
           W=W+diag(d4*ones(size(K)),-4);
           
           
        end
         if mod(i,4)==0 && j==i-2
             W=diag(f0*ones(1,2*m+M-1));
       
         end
          if mod(i,4)==0 && j==i-1
             W=diag(g0*ones(1,2*m+M-1));
              
         end
  
        W(m+M/2+[-m+1:m-1],m+M/2+[-m+1:m-1])=J_cell{i,j}; 
        Jnew_tot((i-1)*(2*m+M-1)+[1:2*m+M-1],(j-1)*(2*m+M-1)+[1:2*m+M-1])=W;
        Jnew{i,j}=W(m+M/2+[-m-M/4+1:m+M/4-1],m+M/2+[-m-M/4+1:m+M/4-1]);
        
            
        
        
    end
   
end
 Anew=inv(cell2mat(cellfun(@(x) x.mid, Jnew,'UniformOutput', false)));
 Anew_cell=mat2cell(Anew, ones(1,s)*(2*m+M/2-1),ones(1,s)*(2*m+M/2-1));
 Anew_tot=cell(s);
  norm_A=zeros(s);
 for i=1:s
    al=vec_al(fix(i/4-1/8)+1,:);
    for j=1:s
        W=zeros(2*m-1+M);
         if i==j
            W=diag(mid(muk(-m-M/2+1:m+M/2-1,al,lambda,T)).^(-1));
         end
         if mod(i,4)==0 && j==i-3
           W=diag(-d0.mid*(mid(muk(-m-M/2+1:m+M/2-1,al,lambda,T))).^(-2));
           K=-m-M/2+1:m+M/2-4-1;
           W=W+diag(-dm4.mid*(mid(muk(K+4,al,lambda,T)).*mid(muk(K,al,lambda,T))).^(-1),4);
           K=-m-M/2+4+1:m+M/2-1;
           W=W+diag(-d4.mid*(mid(muk(K-4,al,lambda,T)).*mid(muk(K,al,lambda,T))).^(-1),-4);
%        
         end
         if mod(i,4)==0 && j==i-2
           W=diag(-f0.mid*(mid(muk(-m-M/2+1:m+M/2-1,al,lambda,T))).^(-2));
         end
         if mod(i,4)==0 && j==i-1
           W=diag(-g0.mid*(mid(muk(-m-M/2+1:m+M/2-1,al,lambda,T))).^(-2));
         end
           MatA=Anew_cell{i,j};
        S=(size(MatA)+1)/2;
         n1=S(1); n2=S(2);
         MatA(n1,n2)=real(MatA(n1,n2));
         MatA(n1,1:n2-1)=flip(conj(MatA(n1,n2+1:end)),2);
         MatA(n1+1:end,:)=flip(flip(conj(MatA(1:n1-1,:)),2),1);
         Anew_cell{i,j}=MatA;
%          
         
          W(m+M/2+[-m-M/4+1:m+M/4-1],m+M/2+[-m-M/4+1:m+M/4-1])=MatA;
          Anew_tot{i,j}=W;
         norm_A(i,j)=norm_dual(W,nu);
     end
       
 end

 Atot=cell2mat(Anew_tot);
 B=intval(Atot)*Jnew_tot-intval(eye(size(Atot)));
end

function q=muk(k,al,lambda,T)
 
    ipi=intval('pi');
q=ipi*1i/(T)*intval(k)+intval(al)*lambda.';

end

function Nor=normAItilde(A,inu)
        m1=(size(A,1)+1)/2;
        m2=(size(A,2)+1)/2;
        K=inu.^intval(abs(-m1+1:1:m1-1))*[abs(intval(A(:,1:4))),abs(intval(A(:,end-3:end)))];
        Nor=max(sup([K./(inu.^intval([abs(-m2+1:1:-m2+4),abs(m2-4:1:m2-1)]))]));

end
     function Nor=norm3diagtilde(A,d0,d4,dm4,inu,al,lambda,T)
        i1=intval(1);
        m1=(size(A,1)+1)/2;
        m2=(size(A,2)+1)/2;
        K0=-m1-4:m1+4;
        Km4=-m1-4:m1;
        K4=-m1:m1+4;
        
        e0=-d0*(muk(K0,al,lambda,T).*muk(K0,al,lambda,T)).^(-i1);
        em4=-dm4*(muk(Km4+4,al,lambda,T).*muk(Km4,al,lambda,T)).^(-i1);
        e4=-d4*(muk(K4+4,al,lambda,T).*muk(K4,al,lambda,T)).^(-i1);
        
        AA=diag(e0)+diag(em4,4)+diag(e4,-4);
        AA(m1+5+[-m1+1:m1-1],m2+5+[-m2+1:m2-1])=intval(A);
        
        M1=(size(AA,1)+1)/2;
        M2=(size(AA,2)+1)/2;
      
        K=inu.^intval(abs(-M1+1:1:M1-1))*[abs(AA(:,1:9)),abs(AA(:,end-8:end))];
        Nor=max(sup([K./(inu.^intval([abs(-M2+1:1:-M2+9),abs(M2-9:1:M2-1)]))]));

     end
     function  Nor=norm44star(A,B,alpha,lambda,T,nu)
        i1=intval(1);
        m1=(size(A,1)+1)/2;       
        M1=(size(B,1)+1)/2;      
        diag1=(muk(-M1+1:1:-m1,alpha,lambda,T)).^(-i1);
        diag2=muk( m1:1:M1-1,alpha,lambda,T).^(-i1);
       Nor=norm_dual( blkdiag(diag(diag1),intval(A),diag(diag2))*B,nu);
     end
     