function [alphas,aquad13,aquad12]=proof_super_term_lorentz(nu,tau,alphas,lambda,N,par,par2)
sigma=par(1);
rho=par(2);
beta=par(3);
isigma=intval(sigma);
irho=intval(rho);
ibeta=intval(beta);
ilambda=intval(lambda);
i0=intval(0);
i2=intval(2);
i1=intval(1);
i3=intval(3);

m_manifold=(size(alphas(2).fc,2)+1)/2;
m=par2(1);
m1=(size(alphas(1).fc,2)+1)/2;
a0=alphas(1);
a0.fc=[zeros(3,m-m1),alphas(1).fc,zeros(3,m-m1)];

Im=eye(2*m-1);
Zm=zeros(2*m-1);
a_01=a0.fc(1,:);
a_02=a0.fc(2,:);
a_03=a0.fc(3,:);


tildea01=toeplitz([a_01(m:end),zeros(1,m-1)],[a_01(m:-1:1),zeros(1,m-1)]);
tildea02=toeplitz([a_02(m:end),zeros(1,m-1)],[a_02(m:-1:1),zeros(1,m-1)]);
tildea03=toeplitz([a_03(m:end),zeros(1,m-1)],[a_03(m:-1:1),zeros(1,m-1)]);

Df_base=intval([sigma*Im,-sigma*Im,Zm;-rho*Im+tildea03,Im,tildea01;-tildea02,-tildea01,beta*Im]);

%%% to be used in Z
a_01=a0.fc(1,:);
a_02=a0.fc(2,:);
a_03=a0.fc(3,:);
 tildea01=intval(toeplitz([a_01(end),zeros(1,2*m-2)],[a_01(end:-1:1),zeros(1,2*m-2)]));
 tildea02=intval(toeplitz([a_02(end),zeros(1,2*m-2)],[a_02(end:-1:1),zeros(1,2*m-2)]));
 tildea03=intval(toeplitz([a_03(end),zeros(1,2*m-2)],[a_03(end:-1:1),zeros(1,2*m-2)]));

 tildea01(:,m:3*m-2)=intval(zeros(2*m-1));
 tildea02(:,m:3*m-2)=intval(zeros(2*m-1));
 tildea03(:,m:3*m-2)=intval(zeros(2*m-1));
 %%%%%%
N_manifold=par2(4);


for tildeN=par2(4)+1:N
[aquad13, aquad12]=compute_a_quad(alphas,N_manifold,tildeN,nu);


[A_alpha,Z0]=compute_A_alpha(sigma,beta,rho,tau,m,ilambda,a0,N_manifold, tildeN,nu,Df_base);
Y=zeros(3,tildeN);
for al=N_manifold+1:min(2*N_manifold,tildeN)
    Y(:,al)=A_alpha(al).norm*[0;aquad13(al+1).norm+aquad13(al+1).eps;aquad12(al+1).norm+aquad12(al+1).eps];
end
    

Z1=intval(zeros(3,tildeN));





   al=N_manifold+1;
   Z1(1,al)=i2*isigma*(abs(muk(m,al,lambda,tau))^(-i1))+...
            norm_dual(A_alpha(al).matij{1,2}*tildea03,nu)+A_alpha(al).norm(1,2)*alphas(1).eps(3)+...
            norm_dual(A_alpha(al).matij{1,2}*tildea01,nu)+A_alpha(al).norm(1,2)*alphas(1).eps(1)+...
            norm_dual(A_alpha(al).matij{1,3}*(-tildea02),nu)+A_alpha(al).norm(1,3)*alphas(1).eps(2)+...
            norm_dual(A_alpha(al).matij{1,3}*(-tildea01),nu)+A_alpha(al).norm(1,3)*alphas(1).eps(1);
        
   Z1(2,al)=(abs(irho)+i1)*(abs(muk(m,al,lambda,tau))^(-i1))+...
            norm_dual(A_alpha(al).matij{2,2}*tildea03,nu)+A_alpha(al).norm(2,2)*alphas(1).eps(3)+(abs(muk(m,al,lambda,tau))^(-i1))*(alphas(1).norm(3)+alphas(1).eps(3))+...
            norm_dual(A_alpha(al).matij{2,2}*tildea01,nu)+A_alpha(al).norm(2,2)*alphas(1).eps(1)+(abs(muk(m,al,lambda,tau))^(-i1))*(alphas(1).norm(1)+alphas(1).eps(1))+...          
            norm_dual(A_alpha(al).matij{2,3}*(-tildea02),nu)+A_alpha(al).norm(2,3)*alphas(1).eps(2)+...
            norm_dual(A_alpha(al).matij{2,3}*(-tildea01),nu)+A_alpha(al).norm(2,3)*alphas(1).eps(1);
      
        
   Z1(3,al)=norm_dual(A_alpha(al).matij{3,2}*tildea03,nu)+A_alpha(al).norm(3,2)*alphas(1).eps(3)+...
            norm_dual(A_alpha(al).matij{3,2}*tildea01,nu)+A_alpha(al).norm(3,2)*alphas(1).eps(1)+...
             norm_dual(A_alpha(al).matij{3,3}*(-tildea02),nu)+A_alpha(al).norm(3,3)*alphas(1).eps(2)+(abs(muk(m,al,lambda,tau))^(-i1))*(alphas(1).norm(2)+alphas(1).eps(2))+...
            norm_dual(A_alpha(al).matij{3,3}*(-tildea01),nu)+A_alpha(al).norm(3,3)*alphas(1).eps(1)+(abs(muk(m,al,lambda,tau))^(-i1))*(alphas(1).norm(1)+alphas(1).eps(1))+...
            ibeta*(abs(muk(m,al,lambda,tau))^(-i1));
          


Z2=intval(zeros(3,1));


p=[ Z2.sup, reshape(Z0.sup,[],1)+reshape(Z1(:,N_manifold+1:end).sup,[],1)-1, reshape(Y(:,N_manifold+1:end),[],1)];

I=zeros(size(p,1),2);
for k=1:size(p,1)
    R=roots(p(k,:));
    R=sort(R);
    Int=R';
    I(k,:)=Int;
end

I=[max(I(:,end-1)) min(I(:,end))];

if norm(imag(I))>0
    display('FAILURE !')
    I=[-1 1];
    success=0;
elseif I(1)<0
    display('FAILURE !')
    I=[-1 1];
    success=0;
else
   
    r=I(1)*1.1;
    ir=intval(r);
    pr=p(:,1)*ir^2+p(:,2)*ir+p(:,3);
    if max(sup(pr))<0
        display(['Computation alpha=' num2str(al) ' (over ' num2str(N) '), SUCCESS !'])
        
    else
        display('FAILURE ! max(sup(pr))>=0')
        success=0;
    end
    success=1;
end
if success==1
    alphas(tildeN+1).n=tildeN;
    alphas(tildeN+1).fc=zeros(3,2*m_manifold-1);
    alphas(tildeN+1).norm=zeros(3,1);
    alphas(tildeN+1).eps=r*ones(3,1);
    N_manifold=N_manifold+1;
end
end
end

function Nor=norm_nu(a,inu)
if size(a,1)==1
    a=a.';
end
m=(length(a)+1)/2;
Nor=sum(abs(a).*repmat((inu.^intval(-m+1:1:m-1)).',1,size(a,2)),1);
end
function Nor=norm_dual(A,nu)
%Assume A maps bi-sequences in bi-sequences
m1=(size(A,1)+1)/2;
m2=(size(A,2)+1)/2;
inu=intval(nu);
if ~isa(A,'intval')
    A=intval(A);
end
K=inu.^intval(abs(-m1+1:1:m1-1))*abs(A);

Nor=max(sup([K./(inu.^intval(abs(-m2+1:1:m2-1)))]));
end

   function q=muk(k,al,lambda,T)
    
    ipi=intval('pi');
q=ipi*1i/(T)*intval(k)+intval(al)*lambda.';

     end
function [a_quad13,a_quad12]=compute_a_quad(alphas,N_man,tildeN,inu)
a_quad13= struct('n', {}, 'fc', {},'eps',{}) ;
a_quad12= struct('n', {}, 'fc', {},'eps',{}) ;

%for al=N_man+1:min(2*N_man,tildeN)%0:2*N_man
    al=tildeN;
    position=num2cell(al+1);
    a_quad13=setfield(a_quad13,position,'n',al);
    a_quad12=setfield(a_quad12,position,'n',al);
    [S13,err13]=compute_quad_int([1,3],al,alphas,alphas,[N_man N_man],inu,N_man);
    a_quad13=setfield(a_quad13,position,'fc',S13);
    a_quad13=setfield(a_quad13,position,'eps',err13.sup);
    a_quad13=setfield(a_quad13,position,'norm', sup(norm_nu(S13,inu)));
    [S12,err12]=compute_quad_int([1,2],al,alphas,alphas,[N_man N_man],inu,N_man);
    a_quad12=setfield(a_quad12,position,'fc',S12);
    a_quad12=setfield(a_quad12,position,'eps',err12.sup);
    a_quad12=setfield(a_quad12,position,'norm', sup(norm_nu(S12,inu)));

    
%end
end

function  [S,error]=compute_quad_int(J,n,alphas1,alphas2,N_alphas,inu,N)
dim_man=length(n);
J(J==0)=[];
% Alphasj=choose_alphas(n,2);
%  if sum(n)>N
%     remove=find(sum((sum(Alphasj(1,:,:),2)-N_alphas(1))>0,1));
%     Alphasj(:,:,remove)=[];
%     remove=find(sum((sum(Alphasj(2,:,:),2)-N_alphas(2))>0,1));
%     Alphasj(:,:,remove)=[];
%  end

S=intval(0);
error=intval(0);
%a_al=cell(2,1);
%for ii=1:size(Alphasj,3)
for v1=1:N%size(Alphasj,3)
   % v1=Alphasj(1,:,ii);
    position1=num2cell(v1+ones(1,dim_man));
    al1=getfield(alphas1,position1,'fc');
    al1=intval(al1(J(1),:));
    Conv=al1;
    %for jj=2:size(Alphasj,1)     %%% in tha case always 2
     %   vj=Alphasj(jj,:,ii);
      v2=N+1-v1;
        position2=num2cell(v2+ones(1,dim_man));
        al2=getfield(alphas2,position2,'fc');
        al2=intval(al2(J(2),:));
        Conv=quadratic_sumFFT_complex_int(Conv.',al2.').';
     %   del=length(Conv)-length([al1,al2])+1;
     %   Conv(1:del/2)=[];
     %   Conv(end-del/2+1:end)=[];
   % end
    S=S+Conv;
    
    
    % if sum(sum(Alphasj(:,:,ii),2)<2)>0
               % Al=Alphasj(:,:,ii);
               Al=[v1;v2];
              %   a_al{1}=al1;
              %   a_al{2}=al2;
          normnu=[norm_nu(al1,inu); norm_nu(al2,inu)];    
         

                error=error+normnu(1)*alphas2((Al(2,1)+1)).eps(J(2))+normnu(2)*alphas1((Al(1,1)+1)).eps(J(1));
                %(prod(factor)-prod(normnu));
end
end

function [s]=quadratic_sumFFT_complex_int(a1,a2)
i2=intval('2');
i4=intval('4');
if size(a1,2)>1
    a1=a1.';
end
if size(a2,2)>1
    a2=a2.';
end
if length(a1)<length(a2)
    a1=[intval(zeros((length(a2)-length(a1))/2,1));a1;intval(zeros((length(a2)-length(a1))/2,1))];
elseif length(a2)<length(a1)
    a2=[intval(zeros((length(a1)-length(a2))/2,1));a2;intval(zeros((length(a1)-length(a2))/2,1))];
end
M=(length(a1)+1)/2;
% We make sure that the inputs are powers of 2 %
M1=(2^ceil(log(4*M-1)/log(2))-4*M)/2;   % Hence 4*M+2*M1 is a power of 2 %
ta1=[intval(zeros(M+M1+1,1));a1;intval(zeros(M+M1,1))];
ta2=[intval(zeros(M+M1+1,1));a2;intval(zeros(M+M1,1))];
tu1=verifyfft(ifftshift(ta1),-1);
tu2=verifyfft(ifftshift(ta2),-1);
F=fftshift(verifyfft(tu1.*tu2,1));
%s=(i4*intval(M)+i2*intval(M1))*F(M1+M+2:M1+3*M,1);
s=(i4*intval(M)+i2*intval(M1))*F(M1+3:M1+4*M-1,1);
end


function [A_al,Z0]=compute_A_alpha(sigma,beta,rho,T,m,lambda,a0,N_manifold, tildeN,nu,Df_base)
A_al=struct([]);
% Im=eye(2*m-1);
% Zm=zeros(2*m-1);
% a_01=a0.fc(1,:);
% a_02=a0.fc(2,:);
% a_03=a0.fc(3,:);
% 
% 
% tildea01=toeplitz([a_01(m:end),zeros(1,m-1)],[a_01(m:-1:1),zeros(1,m-1)]);
% tildea02=toeplitz([a_02(m:end),zeros(1,m-1)],[a_02(m:-1:1),zeros(1,m-1)]);
% tildea03=toeplitz([a_03(m:end),zeros(1,m-1)],[a_03(m:-1:1),zeros(1,m-1)]);

%Df_base=intval([sigma*Im,-sigma*Im,Zm;-rho*Im+tildea03,Im,tildea01;-tildea02,-tildea01,beta*Im]);

for al=N_manifold+1:tildeN
   mu_al=muk([-m+1:m-1],al,lambda,T);
  % Df_al(:,:,al)=Df_base+diag([mu_al,mu_al,mu_al]);
   Df_al=Df_base+diag([mu_al,mu_al,mu_al]);
   A_al(al).n=al;
%   A_al(al).mat=inv(Df_al(:,:,al).mid);
    A_al(al).mat=inv(Df_al.mid);
   A_alcell=mat2cell(A_al(al).mat,(2*m-1)*ones(1,3),(2*m-1)*ones(1,3));
   A_al_cell=struct([]);
   for i=1:3
       for j=1:3
           MatA=A_alcell{i,j};
           MatA=1/2*(conj(flip(flip(MatA,1),2))+MatA);
           A_al_cell{i,j}=MatA;
           dualMatA=norm_dual(MatA,nu);
           A_al(al).norm(i,j)=max(dualMatA,(i==j)*sup(abs(muk(m,al,lambda,T))^(-1)));
           
       end
   end
   A_al(al).mat=cell2mat(A_al_cell);
   A_al(al).matij=A_al_cell;
   R_al=intval(eye(3*(2*m-1)))-intval(A_al(al).mat)*Df_al;%(:,:,al);
   R_al_cell=mat2cell(R_al,(2*m-1)*ones(1,3),(2*m-1)*ones(1,3));
   R_al_norm=zeros(3);
   for i=1:3
       for j=1:3
           R_al_norm(i,j)=norm_dual(R_al_cell{i,j},nu);
       end
   end
   Z0=sum(R_al_norm,2)+2*a0.eps(1)*A_al(al).norm*[0;1;1];
end
end

 