clear
load gamma

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For t in [0 .499], gamma(t)<0 %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

T_mesh_minus=[0 .0001 .001 .01 .05 .2 .4 .49 .499];
n1=length(T_mesh_minus);
sign1=zeros(1,n1-1);

for k=1:n1-1
    t=infsup(T_mesh_minus(k),T_mesh_minus(k+1));
    sign1(k)=value_of_gamma(t,tx);
end

if max(sign1)>=0,
    display('error!')
    return
else
    display(['gamma < 0 on [',num2str(0),' , ',num2str(.499),']'])
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For t in [.499 .5], gamma'(t)>0 %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[sign2]=value_of_gamma_prime(infsup(.499,.5),tx,intval('1.3'));

if sign2<=0,
    display('error!')
    return
else
    display(['gamma_prime > 0 on [',num2str(.499),' , ',num2str(.5),']'])
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For t in [.5 .999], gamma(t)>0 %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

T_mesh_plus=[.5 .5001 .501 .51 .59 .78 .95 .997 .999];
n3=length(T_mesh_plus);
sign3=zeros(1,n3-1);

for k=1:n3-1
    t=infsup(T_mesh_plus(k),T_mesh_plus(k+1));
    sign3(k)=value_of_gamma(t,tx);
end

if max(sign3)<=0,
    display('error!')
    return
else
    display(['gamma > 0 on [',num2str(.5),' , ',num2str(.999),']'])
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% For t in [.999 1], gamma'(t)<0 %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[sign4]=value_of_gamma_prime(infsup(.999,1),tx,intval('1.3'));

if sign4>=0,
    display('error!')
    return
else
    display(['gamma_prime < 0 on [',num2str(.999),' , ',num2str(1),']'])
end

