function Ak=compute_Ak_bridge(gamma)


gamma2=quadratic_sumFFT(gamma);

m=(length(gamma2)+1)/2;
Ak=zeros(4,4,length(gamma2));
Ak(4,1,:)=-3*gamma2;
Ak(:,:,m)=Ak(:,:,m)+[0,1,0,0;0,0,1,0;0,0,0,1;-120,-154,-71,-14];
    
    
end   
 function [s]=quadratic_sumFFT(a)

m=(length(a)+1)/2;

m1=(2^ceil(log(4*m-1)/log(2))-4*m)/2;   % Hence 4*m+2*m1 is a power of 2 %

ta=[zeros(m+m1+1,1);a;zeros(m+m1,1)];
tu=ifft(ifftshift(ta));

F=fftshift(fft(tu.*tu));

s=(4*m+2*m1)*F(m1+3:4*m+m1-1);

end

   
