function [r,aquad,alphas]=proof_super_term(A,B,nu,tau,N_man,Ntilde,alphas,lambda,A_bound,Nstar)
i0=intval(0);
i1=intval(1);
i2=intval(2);
i3=intval(3);
ipi=intval('pi');
itau=intval(tau);
lambda=intval(lambda);



   
%compute \bar a_quad for |alpha|<= N_manifold
aquad=compute_a_quad(alphas,N_man,nu);%,rad_param);



a_quad_0_0=aquad(1,1).fc((size(aquad(1,1).fc,2)+1)/2);
a_quad_0_4=aquad(1,1).fc((size(aquad(1,1).fc,2)+1)/2+4);
a_quad_0_m4=aquad(1,1).fc((size(aquad(1,1).fc,2)+1)/2-4);
d0=intval('120')+i3*(a_quad_0_0+midrad(0,sup(aquad(1,1).eps)));
d4=i3*(a_quad_0_4+midrad(0,sup((aquad(1,1).eps)*nu^(-intval(4)))));
dm4=i3*(a_quad_0_m4+midrad(0,sup((aquad(1,1).eps)*nu^(-intval(4)))));
f0=intval(154);
g0=intval(71);

a_quad_0_star=aquad(1,1).fc;
a_quad_0_star((size(a_quad_0_star,2)+1)/2)=0;
a_quad_0_star((size(a_quad_0_star,2)+1)/2+4)=0;
a_quad_0_star((size(a_quad_0_star,2)+1)/2-4)=0;
norm_a_quad_0_star=norm_nu(a_quad_0_star,nu);
m=(size(alphas(1,1).fc,2)+1)/2;


%%%% Z1 %%%
 m0=(size(a_quad_0_star,2)+1)/2;
tilde0starBig=toeplitz([a_quad_0_star(m0:end),zeros(1,2*m0)],[a_quad_0_star(m0:-1:1),zeros(1,2*m0)]);
m0star=(size(tilde0starBig,1)+1)/2;
tilde0starBig(m0star+[-m+1:m-1],m0star+[-m+1:m-1])=zeros(2*m-1);
tilde0star=tilde0starBig(m0star+[-m-3:m+3],m0star+[-m-3:m+3]);
epsilon02=aquad(1,1).eps;
vec_al=[];
for modN=N_man+1:Ntilde
    for al1=modN:-1:0
        al2=modN-al1;     
        vec_al=[vec_al;[al1,al2]];
    end
end

Z0_last=zeros(4,1);
A_last=zeros(4);
for n=1:size(vec_al,1)
    al=vec_al(n,:);
    ial=intval(al);
    ater=compute_a_cubic(al,alphas,aquad,nu,N_man);
    Y=[];
    Z0=[];
    
     Y=intval(A(al(1)+1,al(2)+1).norm(:,4))*(intval(ater(1).norm)+intval(ater(1).eps));
    

        
    Z0=sum(intval(B(al(1)+1,al(2)+1).norm),2);

  Z1(1,1)= max([sup(abs(muk(m+4,ial,lambda,itau)^(-i1))) ,normAItilde(A(al(1)+1,al(2)+1).Am{1,1},nu)])+...
               normAItilde(A(al(1)+1,al(2)+1).Am{1,2},nu)+normAItilde(A(al(1)+1,al(2)+1).Am{1,3},nu)+...
               intval(14)*normAItilde(A(al(1)+1,al(2)+1).Am{1,4},nu)+i3*norm_dual(A(al(1)+1,al(2)+1).Am{1,4}*tilde0star,nu)+i3*A(al(1)+1,al(2)+1).norm(1,4)*epsilon02;%+...
              
      Z1(2,1)= max([sup(abs(muk(m+4,ial,lambda,itau)^(-i1))) ,normAItilde(A(al(1)+1,al(2)+1).Am{2,2},nu)])+...
               normAItilde(A(al(1)+1,al(2)+1).Am{2,1},nu)+normAItilde(A(al(1)+1,al(2)+1).Am{2,3},nu)+...
               intval(14)*normAItilde(A(al(1)+1,al(2)+1).Am{2,4},nu)+i3*norm_dual(A(al(1)+1,al(2)+1).Am{2,4}*tilde0star,nu)+i3*A(al(1)+1,al(2)+1).norm(2,4)*epsilon02;
               
      Z1(3,1)= max([sup(abs(muk(m+4,ial,lambda,itau)^(-i1))) ,normAItilde(A(al(1)+1,al(2)+1).Am{3,3},nu)])+...
               normAItilde(A(al(1)+1,al(2)+1).Am{3,1},nu)+normAItilde(A(al(1)+1,al(2)+1).Am{3,2},nu)+...
               intval(14)*normAItilde(A(al(1)+1,al(2)+1).Am{3,4},nu)+i3*norm_dual(A(al(1)+1,al(2)+1).Am{3,4}*tilde0star,nu)+i3*A(al(1)+1,al(2)+1).norm(3,4)*epsilon02;
               
      Z1(4,1)= norm3diagtilde(A(al(1)+1,al(2)+1).Am{4,1},d0,d4,dm4,nu,ial,lambda,itau)+...
               max([sup(abs(f0)*muk(m+4,ial,lambda,itau)^(-i2)) ,normAItilde(A(al(1)+1,al(2)+1).Am{4,2},nu)])+...
               max([sup(abs(g0)*muk(m+4,ial,lambda,itau)^(-i2)) ,normAItilde(A(al(1)+1,al(2)+1).Am{4,3},nu)])+...
               intval(14)*normAItilde(A(al(1)+1,al(2)+1).Am{4,4},nu)+i3*norm44star(A(al(1)+1,al(2)+1).Am{4,4},tilde0starBig,ial,lambda,itau,nu)+i3*A(al(1)+1,al(2)+1).norm(4,4)*epsilon02;%+...
               %i3*A(al(1)+1,al(2)+1).norm(4,4)*a2delta;

Z2=10^(-15)*intval(zeros(4,1));

if sum(al)==Ntilde
    Z0_last=max([Z0_last,Z0.sup],[],2);
    A_last=max(A_last,A_bound(al(1)+1,al(2)+1).norm);
    
end

p=[ Z2.sup, reshape(Z0.sup,[],1)+reshape(Z1.sup,[],1)-1, reshape(Y.sup,[],1)];

I=zeros(size(p,1),2);
for k=1:size(p,1)
    R=roots(p(k,:));
    R=sort(R);
    Int=R';
    I(k,:)=Int;
end

I=[max(I(:,end-1)) min(I(:,end))];

if norm(imag(I))>0
    display('FAILURE !')
    I=[-1 1];
    success=0;
    break
elseif I(1)<0
    display('FAILURE !')
    I=[-1 1];
    success=0;
    break
else
   
    r=I(1)*1.1;
    ir=intval(r);
    pr=p(:,1)*ir^2+p(:,2)*ir+p(:,3);
    if max(sup(pr))<0
        display(['Computation alpha=[ ',num2str(al),'] SUCCESS !'])
       
    else
        display('FAILURE ! max(sup(pr))>=0')
        display(['Computation alpha=[ ',num2str(al),'] FAIL !'])
        success=0;
        break
    end
    success=1;
end
if success==1
    alphas(al(1)+1,al(2)+1).n=al;
    alphas(al(1)+1,al(2)+1).fc=zeros(4,2*m-1);
    alphas(al(1)+1,al(2)+1).norm=zeros(4,1);
    alphas(al(1)+1,al(2)+1).eps=r*ones(4,1);
    aquad(al(1)+1,al(2)+1).eps=compute_a2_eps(al,alphas,N_man);

end
end


aquad=compute_aquad_eps(aquad,alphas,N_man,Ntilde);

ater_bound=compute_bound_a3(aquad,alphas,N_man,Ntilde);
 a2deltamax=i0;
 for i=2:numel(aquad)
      if isempty(aquad(i).eps)==0
      a2deltamax=a2deltamax+intval(aquad(i).norm)+intval(aquad(i).eps);
      end
 end
 total_norm_a=0;
 number_al=0;
for i=1:numel(alphas)
      if isempty(alphas(i).n)==0
          total_norm_a=total_norm_a+intval(alphas(i).norm(1))+intval(alphas(i).eps(1));
          number_al=number_al+1;
      end
end
 
Y_last=A_last*[0;0;0;ater_bound];
Zlast(1,1)=A_last(1,1)+A_last(1,2)+A_last(1,3)+...
               intval(14)*A_last(1,4)+3*A_last(1,4)*norm_a_quad_0_star+...
               i3*A_last(1,4)*a2deltamax;
      Zlast(2,1)=A_last(2,1)+A_last(2,2)+A_last(2,3)+...
               intval(14)*A_last(2,4)+3*A_last(2,4)*norm_a_quad_0_star+...
               i3*A_last(2,4)*a2deltamax;
      Zlast(3,1)=A_last(3,1)+A_last(3,2)+A_last(3,3)+...
               intval(14)*A_last(3,4)+3*A_last(3,4)*norm_a_quad_0_star+...
               i3*A_last(3,4)*a2deltamax;
      Zlast(4,1)=A_last(4,1)+A_last(4,2)+A_last(4,3)+...
               intval(14)*A_last(4,4)+i3*A_last(4,4)*norm_a_quad_0_star+...
               i3*A_last(4,4)*a2deltamax;
  
Z2last=[0;0;0;total_norm_a*((Nstar/2+1)^2-2*number_al)];
Z3last=[0;0;0;1/4*(Nstar/2+2)^2*(Nstar/2+1)^2];

ip=[Z3last Z2last.sup Z0_last+sup(Zlast.sup)-1 Y_last];
p=mid(ip);



I=zeros(size(p,1),3);
for k=1:size(p,1)
    R=roots(p(k,:));
    R=sort(R);
    Int=R';
    I(k,:)=Int;
end

I=[max(I(:,end-1)) min(I(:,end))];

if norm(imag(I))>0
    display('FAILURE !')
    I=[-1 1];
    success=0;
elseif I(1)<0
    display('FAILURE !')
    I=[-1 1];
    success=0;
else
    
    r=I(1)*1.1;
    ir=intval(r);
    pr=p(:,1)*ir^2+p(:,2)*ir+p(:,3);
    if max(sup(pr))<0
        display('SUCCESS !')
       
        
    else
        display('FAILURE ! max(sup(pr))>=0')
    end
    success=1;
end
end




function a2_eps=compute_a2_eps(n,alphas,N_man)
i2=intval(2);
Alphasj=choose_alphas(n,2);
a2_eps=0;
for ii=1:size(Alphasj,3)
    v1=Alphasj(1,:,ii);
    v2=Alphasj(2,:,ii);
    a2_eps=a2_eps+alphas(v1(1)+1,v1(2)+1).eps(1)*alphas(v2(1)+1,v2(2)+1).eps(1);
    if sum(v2)<=N_man
        a2_eps=a2_eps+i2*alphas(v1(1)+1,v1(2)+1).eps(1)*alphas(v2(1)+1,v2(2)+1).norm;
    end
end

end



function a_quad=compute_a_quad(alphas,N_man,inu)

a_quad= struct('n', {}, 'fc', {},'eps',{}) ;
vec_al=[];
for modN=0:2*N_man
    for al1=modN:-1:0
        al2=modN-al1;
      
        vec_al=[vec_al;[al1,al2]];
    end
end
for i=1:size(vec_al,1)
    al=vec_al(i,:);
    position=num2cell(al+1);
    a_quad=setfield(a_quad,position,'n',al);
    [S,a2_norm,a2_eps]=compute_quad_int([1,1],al,alphas,inu,N_man);
    a_quad=setfield(a_quad,position,'fc',S);
    a_quad=setfield(a_quad,position,'eps',a2_eps);
    a_quad=setfield(a_quad,position,'norm', a2_norm);

    
end
end


% function aquad=compute_aquad_eps1(aquad,alphas,N_man)
% 
% vec_al=[];
% for modN=3*N_man+1:6*N_man
%     for al1=modN:-1:0
%         al2=modN-al1;
%       
%         vec_al=[vec_al;[al1,al2]];
%     end
% end
% 
% Al2=[];
% for modN=0:3*N_man
%     for al1=modN:-1:0
%         al2=modN-al1;
%       
%         Al2=[Al2;[al1,al2]];
%     end
% end
% for i=1:size(vec_al,1)
%     al=vec_al(i,:);
%     a2_eps=0;
%     for j=1:size(Al2,1)
%         al2=Al2(j,:);
%         al1=al-al2;
%         if min(al1)>=0 && sum(al1)<=3*N_man
%             a2_eps=a2_eps+alphas(al1(1)+1,al1(2)+1).eps(1)*alphas(al2(1)+1,al2(2)+1).eps(1);
%             if sum(al1)<N_man
%                 a2_eps=a2_eps+alphas(al1(1)+1,al1(2)+1).norm*alphas(al2(1)+1,al2(2)+1).eps(1);
%             end
%         end
%     end
%     aquad(al(1)+1,al(2)+1).eps=a2_eps;
% end
% end

function  [S,a2_norm,a2_eps]=compute_quad_int(J,n,alphas,inu,N)
i2=intval(2);
dim_man=length(n);
J(J==0)=[];
Alphasj=choose_alphas(n,2);


S=intval(0);
a2_eps=intval(0);

for ii=1:size(Alphasj,3)
    
    v1=Alphasj(1,:,ii);
    v2=Alphasj(2,:,ii);
    
    position1=num2cell(v1+ones(1,dim_man));
    position2=num2cell(v2+ones(1,dim_man));
    if (sum(v1)<=N) && (sum(v2)<=N)
    al1=getfield(alphas,position1,'fc');
    al1=intval(al1(J(1),:));
    al2=getfield(alphas,position2,'fc');
    al2=intval(al2(J(2),:));
    Conv=quadratic_sumFFT_complex_int(al1.',al2.').';

    S=S+Conv;
    end
    if sum(n)<=3
     a2_eps=a2_eps+intval(alphas(v1(1)+1,v1(2)+1).eps(J(1)))*intval(alphas(v2(1)+1,v2(2)+1).eps(J(2)));
     if sum(v2)<=N
         a2_eps=a2_eps+i2*intval(alphas(v1(1)+1,v1(2)+1).eps(J(1)))*alphas(v2(1)+1,v2(2)+1).norm;
     end
    end
    

end
a2_norm=norm_nu(S,inu);
end

function [s]=quadratic_sumFFT_complex_int(a1,a2)
i2=intval('2');
i4=intval('4');
if size(a1,2)>1
    a1=a1.';
end
if size(a2,2)>1
    a2=a2.';
end
if length(a1)<length(a2)
    a1=[intval(zeros((length(a2)-length(a1))/2,1));a1;intval(zeros((length(a2)-length(a1))/2,1))];
elseif length(a2)<length(a1)
    a2=[intval(zeros((length(a1)-length(a2))/2,1));a2;intval(zeros((length(a1)-length(a2))/2,1))];
end
M=(length(a1)+1)/2;
% We make sure that the inputs are powers of 2 %
M1=(2^ceil(log(4*M-1)/log(2))-4*M)/2;   % Hence 4*M+2*M1 is a power of 2 %
ta1=[intval(zeros(M+M1+1,1));a1;intval(zeros(M+M1,1))];
ta2=[intval(zeros(M+M1+1,1));a2;intval(zeros(M+M1,1))];
tu1=verifyfft(ifftshift(ta1),-1);
tu2=verifyfft(ifftshift(ta2),-1);
F=fftshift(verifyfft(tu1.*tu2,1));

s=(i4*intval(M)+i2*intval(M1))*F(M1+3:M1+4*M-1,1);
end
function Nor=norm_nu(a,inu)
if size(a,2)==1
    a=a.';
end

m=(length(a)+1)/2;
Nor=abs(a)*((inu.^intval(abs(-m+1:1:m-1))).');

end



 function  a_cubic=compute_a_cubic(al,alphas,aquad,nu,N_man)
      
          a_cubic= struct('n', {}, 'fc', {},'eps',{},'norm',{}) ;
     

              [S,a3_norm,a3_eps]=compute_ter_int([1,1,1],al,alphas,aquad,nu,N_man);
              a_cubic(1).norm=a3_norm;
              a_cubic(1).eps=a3_eps;


    
    function  [S,a3_norm,a3_eps]=compute_ter_int(J,n,alphas,aquad,inu,N)
  
i2=intval(2);
i3=intval(3);
dim_man=length(n);
J(J==0)=[];
Alphasj3=choose_alphas(n,3);
Alphasj2=choose_alphas(n,2);

remove=[];
for jj=1:size(Alphasj3,3)
    if min(sum(abs(Alphasj3(:,:,jj)-repmat(n,3,1)),2))==0
        remove=[remove,jj];
    end
end
  Alphasj3(:,:,remove)=[];  
  remove=[];
 for jj=1:size(Alphasj2,3)
    if sum(abs(Alphasj2(2,:,jj)))>2*N || min(sum(abs(Alphasj2(:,:,jj)-repmat(n,2,1)),2))==0
        remove=[remove,jj];
    end
 end
 Alphasj2(:,:,remove)=[];


S=intval(0);
a3_eps=intval(0);

for ii=1:size(Alphasj3,3)
    
    v1=Alphasj3(1,:,ii);
    v2=Alphasj3(2,:,ii);
    v3=Alphasj3(3,:,ii);
    position1=num2cell(v1+ones(1,dim_man));
    position2=num2cell(v2+ones(1,dim_man));
    position3=num2cell(v3+ones(1,dim_man));
      if (sum(v3)<=N)
          
          
          a3_eps=a3_eps+i2*alphas(v3(1)+1,v3(2)+1).eps(J(3))*intval(alphas(v1(1)+1,v1(2)+1).eps(J(1)))*intval(alphas(v2(1)+1,v2(2)+1).eps(J(2)));
          if (sum(v2)<=N) && (sum(v1)<=N)
              
    al1=getfield(alphas,position1,'fc');
    al1=intval(al1(J(1),:));
    al2=getfield(alphas,position2,'fc');
    al2=intval(al2(J(2),:));
    al3=getfield(alphas,position3,'fc');
    al3=intval(al3(J(3),:));
    
    Conv=quadratic_sumFFT_complex_int(al1.',al2.').';

     Conv3=quadratic_sumFFT_complex_int(Conv.',al3.').';
      S=S+Conv3;
          end
      end
      a3_eps=a3_eps+alphas(v3(1)+1,v3(2)+1).eps(J(3))*intval(alphas(v1(1)+1,v1(2)+1).eps(J(1)))*intval(alphas(v2(1)+1,v2(2)+1).eps(J(2)));
end
for ii=1:size(Alphasj2,3)
    v1=Alphasj2(1,:,ii);
    v2=Alphasj2(2,:,ii);
    a3_eps=a3_eps+i3*alphas(v1(1)+1,v1(2)+1).eps(J(1))*aquad(v2(1)+1,v2(2)+1).norm;
end
a3_norm=norm_nu(S,inu);

     
   
  end
         
          
          
     end



     function q=muk(k,al,lambda,T)
    
    ipi=intval('pi');
q=ipi*1i/(T)*intval(k)+intval(al)*lambda.';

     end

     function Nor=normAItilde(A,nu)
        m1=(size(A,1)+1)/2;
        m2=(size(A,2)+1)/2;
        inu=intval(nu);
        
        K=inu.^intval(abs(-m1+1:1:m1-1))*[abs(intval(A(:,1:4))),abs(intval(A(:,end-3:end)))];
        Nor=max(sup([K./(inu.^intval([abs(-m2+1:1:-m2+4),abs(m2-4:1:m2-1)]))]));

     end
     function Nor=norm_dual(A,nu)
%Assume A maps bi-sequences in bi-sequences
m1=(size(A,1)+1)/2;
m2=(size(A,2)+1)/2;
inu=intval(nu);
if ~isa(A,'intval')
    A=intval(A);
end
K=inu.^intval(abs(-m1+1:1:m1-1))*abs(A);

Nor=max(sup([K./(inu.^intval(abs(-m2+1:1:m2-1)))]));
     end
     function Nor=norm3diagtilde(A,d0,d4,dm4,nu,al,lambda,T)
        i1=intval(1);
        m1=(size(A,1)+1)/2;
        m2=(size(A,2)+1)/2;
        K0=-m1-4:m1+4;
        Km4=-m1-4:m1;
        K4=-m1:m1+4;
        
        e0=-d0*(muk(K0,al,lambda,T).*muk(K0,al,lambda,T)).^(-i1);
        em4=-dm4*(muk(Km4+4,al,lambda,T).*muk(Km4,al,lambda,T)).^(-i1);
        e4=-d4*(muk(K4+4,al,lambda,T).*muk(K4,al,lambda,T)).^(-i1);
        
        AA=diag(e0)+diag(em4,4)+diag(e4,-4);
        AA(m1+5+[-m1+1:m1-1],m2+5+[-m2+1:m2-1])=intval(A);
        
        M1=(size(AA,1)+1)/2;
        M2=(size(AA,2)+1)/2;
        inu=intval(nu);
        K=inu.^intval(abs(-M1+1:1:M1-1))*[abs(AA(:,1:9)),abs(AA(:,end-8:end))];
        Nor=max(sup([K./(inu.^intval([abs(-M2+1:1:-M2+9),abs(M2-9:1:M2-1)]))]));

     end
     
     function  Nor=norm44star(A,B,alpha,lambda,T,nu)
        i1=intval(1);
        m1=(size(A,1)+1)/2;
       
        M1=(size(B,1)+1)/2;
       
        diag1=(muk(-M1+1:1:-m1,alpha,lambda,T)).^(-i1);
        diag2=muk( m1:1:M1-1,alpha,lambda,T).^(-i1);
       Nor=norm_dual( blkdiag(diag(diag1),intval(A),diag(diag2))*B,nu);
     end
     
    
     