function r=enc_eig(A,V,l)
n= size(V,1);
iV=intval(V);
i2=intval(2);
[m,IV]=max(abs(V));
O=ones(n,1);
df=intval(A)-intval(l)*speye(n);
F=df*iV;
df(:,IV)=-iV;
R=inv(mid(df));
Y=sup(abs(intval(R)*F));
Z0=sup(abs(eye(n)-intval(R)*df))*O;
O(IV)=0;
Z1=i2*abs(R)*O;
rd=[Z1,Z0-ones(n,1),Y];          % coefficients of radii polynomials [r^2,r,const]
r=evaluate_intersection_int(rd); % evaluate where all the polynomials are negative



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    function neg_inter=evaluate_intersection_int(rd)
        rd=intval(rd);
        neg_inter=NaN;
        Rm=(-rd(:,2)-sqrt(rd(:,2).^i2-intval(4)*rd(:,1).*rd(:,3)))./(i2*rd(:,1));
        Rp=-Rm-rd(:,2)./rd(:,1);
        ISCOMP=find(isreal(Rp)+isreal(Rm)<2, 1);
        if isempty(ISCOMP)==0
            'error: a polynomial is positive everywhere'
            return
        end
        intersection=[max(Rm.sup),min(Rp.inf)];
        if intersection(1)<intersection(2)
            neg_inter=intersection(1);
        end
        
    end
end


   